Skip to main content

Graph - Medium Level - Question 1

Graph - Medium Level - Question 1


Leetcode 2049. Count Nodes With the Highest Score

There is a binary tree rooted at 0 consisting of n nodes. The nodes are labeled from 0 to n - 1. You are given a 0-indexed integer array parents representing the tree, where parents[i] is the parent of node i. Since node 0 is the root, parents[0] == -1.

Each node has a score. To find the score of a node, consider if the node and the edges connected to it were removed. The tree would become one or more non-empty subtrees. The size of a subtree is the number of the nodes in it. The score of the node is the product of the sizes of all those subtrees.

Return the number of nodes that have the highest score.


Constraints:


n == parents.length

2 <= n <= 10^5

parents[0] == -1

0 <= parents[i] <= n - 1 for i != 0

parents represents a valid binary tree.


Analysis:

If we have had the binary tree, then we just can do a top-down count, to count the number of nodes for the sub-tree with the root as the current nodes. But we do not have the tree, instead, we only know the parents of each nodes.

So we need to construct the binary tree by ourselves. This process can be generalized to build a graph.

Since we need to know the number of nodes of the subtree with the root as the current node, so we need to know the children nodes of each nodes. And also we need to know the root.

For this question, we can use a two dimensional array to simply the graph notation. The array index would be the node index, and the array contents are for the children nodes.

After having the graph, we can do a top-down traversal to count the number of nodes "below" the node, starting with the root node. A dynamical programming trick is needed here as well, to record the numbers.

After having all the information we need, we can check each node, to see which one give the highest score, and count its times. If the node is the root, we just need to check its children nodes.


See the code below:


class Solution {
public:
    int countHighestScoreNodes(vector<int>& parents) {
        int n = parents.size(), root = 0;
        long res = -1, num = 0;
        vector<long> dp(n, 0);
        vector<vector<long>> g(n);
        for(int i=0; i<n; ++i) {
            if(parents[i] == -1) root = i;
            else g[parents[i]].push_back(i);
        }
        ct(root, g, dp);
        for(int i=0; i<n; ++i) {
            // cout<<i<<" "<<dp[i]<<endl;
        }
        for(int i=0; i<n; ++i) {
            long one = 0;
            if(i == root) {
                if(g[i].size() == 2) one = dp[g[i][0]]*dp[g[i][1]];
                else if(g[i].size() == 1) one = dp[g[i][0]];
            }
            else {
                if(g[i].size() == 0) one = dp[root] - 1;
                else if(g[i].size() == 1) one = dp[g[i][0]] *(dp[root] - dp[i]);
                else if(g[i].size() == 2) one = dp[g[i][0]] * dp[g[i][1]] * (dp[root] - dp[i]);
            }
            if(res < one) {
                res = one;
                num = 1;
            }
            else if(res == one) ++num;
        }
        return num;
    }
private:
    long ct(int root, vector<vector<long>>& g, vector<long>& dp) {
        for(auto &a : g[root]) {
            dp[root] += ct(a, g, dp);
        }
        return dp[root] += 1;
    }
};


Made some change to let the code can be used for a n-ary tree:


class Solution {
public:
    int countHighestScoreNodes(vector<int>& parents) {
        int n = parents.size(), root = 0;
        long res = -1, num = 0;
        vector<long> dp(n, 0);
        vector<vector<long>> g(n);
        for(int i=0; i<n; ++i) {
            if(parents[i] == -1) root = i;
            else g[parents[i]].push_back(i);
        }
        ct(root, g, dp);
        for(int i=0; i<n; ++i) {
            long one = i == root ? 1 : dp[root] - dp[i];
            for(auto &a : g[i]) {
                one *= dp[a];
            }
            if(res < one) {
                res = one;
                num = 1;
            }
            else if(res == one) ++num;
        }
        return num;
    }
private:
    long ct(int root, vector<vector<long>>& g, vector<long>& dp) {
        for(auto &a : g[root]) {
            dp[root] += ct(a, g, dp);
        }
        return dp[root] += 1;
    }
};


Upper Layer

Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once...

Bit Manipulation - Example

  Leetcode 136 Single Number Given a non-empty array of integers nums, every element appears twice except for one. Find that single one. You must implement a solution with a linear runtime complexity and use only constant extra space. Constraints: 1 <= nums.length <= 3 * 10^4 -3 * 10^4 <= nums[i] <= 3 * 10^4 Each element in the array appears twice except for one element which appears only once. Analysis: If there is no space limitation, this question can be solved by counting easily. But counting requires additional space. Here we can use xor (^) operation based on some interesting observations:  A^A = 0, here A is any number A^0 = A, here A is any number Since all the number appears twice except one, then all the number appear even numbers will be cancelled out, and only the number appears one time is left, which is what we want. See the code below: class Solution { public: int singleNumber(vector<int>& nums) { int res = 0; for(auto ...

Rolling Hash

Rolling hash is one common trick used to increase efficiency of substring comparisons by compressing (or hashing) a string into a integer. After this step, we can compare two strings directly without comparing each chars. So the efficiency can be increased from O(N) to O(1). So how to implement the rolling hash? First we need to choose a base for the expansion and a modulo to mod. The basic formula is (suppose the window is n, and the rolling direction is from left to right), HashVal = (A1*p^(n-1) + A2*p^(n-2) + ... + An-1*p^1 + An*p^0)%mod where HashVal is the hash value, Ai is the ith element, p is the base, and mod is the modulo. To avoid collision as much as we can, p and modulo usually need to be large prime numbers. One corner case is that the base order in the above formula cannot be reversed. Or to be more clear, if the rolling direction is from left to right in an array, the first element should be in the highest order of the base, or times p^(n-1), and the last element times ...